import os
import sys
import re
forge = sys.modules["forge"]

def setup(module):
	arnoldArch = ""
	arnoldMajor = ""
	arnoldMinor = ""
	arnoldFix = ""
	for line in open(forge.arnold_include + "/ai_version.h").readlines():
		if re.match("#define AI_VERSION_ARCH_NUM.*", line):
			arnoldArch = line.split()[2].rstrip()
		if re.match("#define AI_VERSION_MAJOR_NUM.*", line):
			arnoldMajor = line.split()[2].rstrip()
		if re.match("#define AI_VERSION_MINOR_NUM.*", line):
			arnoldMinor = line.split()[2].rstrip()
		if re.match("#define AI_VERSION_FIX.*", line):
			arnoldFix = line.split()[2].rstrip()[1:-1]

	version = arnoldArch + "." + arnoldMajor + "." + arnoldMinor + "." + arnoldFix
	if version != "...":
		sys.stdout.write(" " + version)

	srcList = [	"ArnoldNode",
				"ArnoldShader",
				"ShaderVariablesArnold",
				"arnold.pmh",
				"arnoldDL" ]

	dll = module.DLL( "fexArnoldDL", srcList )

	module.includemap = {}
	module.includemap['arnold'] = forge.arnold_include

	dll.linkmap = {}
	dll.linkmap['arnold'] = "-Xlinker -rpath='" + forge.arnold_lib + "'"
	dll.linkmap['arnold'] = '-L' + forge.arnold_lib + ' -lai'

	deplibs = forge.corelibs+ [
				"fexSurfaceDLLib",
				"fexTerminalDLLib"	]

	forge.deps( ["fexArnoldDLLib"], deplibs )

	arnoldPath = os.path.join(forge.libPath, 'arnold')
	if os.path.isdir(arnoldPath) == 0:
		os.makedirs(arnoldPath, 0755)

	dest = os.path.join(arnoldPath, 'libfexArnoldDL.so')
	if os.path.lexists(dest) == 0:
		os.symlink("../libfexArnoldDL.so", dest)


def auto(module):
	if forge.arnold_include == '' or forge.arnold_lib == '':
		return 'unset'

	test_file = """
#include "ai.h"

int main(void)
{
	return(0);
}
    \n"""

	forge.includemap['arnold'] = forge.arnold_include

#	forge.linkmap['arnold'] = "-Xlinker -rpath='" + forge.arnold_lib + "'"
#	forge.linkmap['arnold'] = '-L' + forge.arnold_lib + ' -lai'

	result = forge.cctest(test_file)

	forge.includemap.pop('arnold', None)
	forge.linkmap.pop('arnold', None)

	return result
