import sys
import os
forge = sys.modules["forge"]

def setup(module):


	srcList = [	"lua.pmh",
				"LuaContext",
				"LuaObject",
				"LuaType",
				"LuaComponent",
				"LuaBind",
				"LuaHandler",
				"LuaIterate",
				"SurfaceAccessibleLua",
				"luaDL" ]

	if 'architecture' in forge.module_list and os.path.exists('ext/architecture'):
		module.cppmap['architecture'] = ' -DFE_LUA_ARCHITECTURE'
	else:
		forge.color_on(0, forge.BLUE)
		sys.stdout.write(" -architecture")
		forge.color_off()

	dll = module.DLL( "fexLuaDL", srcList )

	#dll.linkmap = { 'lua' : '-L%s -llua -llualib' %  os.path.join(module.modPath,'lua','lib')}

	deplibs = forge.corelibs+ [
			"feSignalLib",
			"fexDataToolDLLib",
			"fexSurfaceDLLib",
			"luaLib",
			"lualbLib" ]

	forge.deps( ["fexLuaDLLib"], deplibs )

	module.includemap = { 'lua' : os.path.join(module.modPath,'lua','src') }

	lua = module.Module( 'lua' )
	module.AddDep(lua)

	forge.tests += [
		("inspect.exe",		"fexLuaDL",						None,		None) ]

	module.Module( 'test' )
