/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include <network/network.pmh>

namespace fe
{

Library *CreateNetworkLibrary(sp<Master>)
{
	Library *pLibrary = new Library();
	pLibrary->setName("default_network");
	pLibrary->add<BSDServer>("ServerI.BSDServer.fe");
	pLibrary->add<BSDClient>("ClientI.BSDClient.fe");

#if FE_BOOST_FILESYSTEM
	pLibrary->add<MultiGroupWriter>("HandlerI.MultiGroupWriter.fe");
	pLibrary->add<MultiGroupReader>("HandlerI.MultiGroupReader.fe");
#endif

	return pLibrary;
}

}
