import sys
import re
forge = sys.modules["forge"]

def setup(module):
	srcList = [	"operator.pmh",
				"BloatOp",
				"ClaspOp",
				"ConnectOp",
				"CurveCreateOp",
				"CurveSampleOp",
				"ExcarnateOp",
				"ExportOp",
				"FollicleOp",
				"GroupOp",
				"HammerOp",
				"HingeOp",
				"HobbleOp",
				"InfluenceOp",
				"ImportOp",
				"LengthCorrectOp",
				"MapOp",
				"MirrorOp",
				"NoiseOp",
				"NullOp",
				"OffsetOp",
				"OpenSubdivOp",
				"PartitionOp",
				"PoisonOp",
				"PuppetOp",
				"QuiltOp",
				"RasterOp",
				"RulerOp",
				"SpreadsheetOp",
				"StashOp",
				"SubdivideOp",
				"SurfaceAttrConformOp",
				"SurfaceAttrCopyOp",
				"SurfaceAttrCreateOp",
				"SurfaceAttrLabOp",
				"SurfaceAttrRampOp",
				"SurfaceBindOp",
				"SurfaceCopyOp",
				"SurfaceMetricOp",
				"SurfaceNormalOp",
				"SurfaceProxyOp",
				"SurfaceSampleOp",
				"SurfaceSummaryOp",
				"SurfaceWalkOp",
				"SurfaceWrapOp",
				"TransformManipulator",
				"ValidateOp",
				"ValueManipulator",
				"operatorDL" ]

	manifest = 'ext/operator/manifest.cc'
	with open(manifest, 'w') as outfile:
		outfile.write("")
	for src in srcList:
			if re.compile(r'(.*)Op$').match(src):
				with open(manifest, 'a') as outfile:
					outfile.write('\tspManifest->catalog<String>(\n'+
							'\t\t\t"OperatorSurfaceI.' + src + '.fe")='+
							'"fexOperatorDL";\n');

	dll = module.DLL( "fexOperatorDL", srcList )

	deplibs = forge.corelibs+ [
				"fexGeometryDLLib",
				"fexMathLib",
				"fexOperateDLLib",
				"fexSurfaceDLLib",
				"fexWindowLib"	]

	forge.deps( ["fexOperatorDLLib"], deplibs )

	forge.tests += [
		("inspect.exe",	"fexOperatorDL",					None,	None) ]

	module.Module('test')
