import os
import sys
import re
forge = sys.modules["forge"]

def setup(module):
	srcList = [	"oplab.pmh",
				"BindEditOp",
				"CurvaceousOp",
				"FusionOp",
				"GridWrapOp",
				"MultiModOp",
				"NexusOp",
				"NetworkOp",
				"PreviewOp",
				"SurfaceViewerOp",
				"XRayOp",
				"oplabDL" ]

	manifest = 'ext/oplab/manifest.cc'
	with open(manifest, 'w') as outfile:
		outfile.write("")
	for src in srcList:
			extra = ""
			if src == "SurfaceViewerOp":
				extra = ".nohoudini"
			if re.compile(r'(.*)Op$').match(src):
				with open(manifest, 'a') as outfile:
					outfile.write('\tspManifest->catalog<String>(\n'+
							'\t\t\t"OperatorSurfaceI.' + src + '.fe' +
							extra + '")='+ '"fexOpLabDL";\n');

	dll = module.DLL( "fexOpLabDL", srcList )

	deplibs = forge.corelibs+ [
				"fexMathLib",
				"fexOperateDLLib",
				"fexOperatorDLLib",
				"fexSurfaceDLLib",
				"fexWindowLib"	]

	if 'graphviz' in forge.module_list and os.path.exists('ext/graphviz') and os.path.exists('/usr/include/graphviz/gvc.h'):
		module.cppmap = {}
		module.cppmap['meta'] = ' -DFE_USE_GRAPHVIZ'
	else:
		forge.color_on(0, forge.BLUE)
		sys.stdout.write(" -graphviz")
		forge.color_off()

	if 'viewer' in forge.module_list and os.path.exists('ext/viewer'):
		deplibs += [ "fexViewerLib" ]
	else:
		forge.color_on(0, forge.BLUE)
		sys.stdout.write(" -viewer")
		forge.color_off()

	forge.deps( ["fexOpLabDLLib"], deplibs )

	forge.tests += [
		("inspect.exe",	"fexOpLabDL",					None,	None) ]

