/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include <usd/hydra.pmh>

#include "platform/dlCore.cc"

using namespace fe;

extern "C"
{

FE_DL_EXPORT void ListDependencies(List<String*>& list)
{
	list.append(new String("fexOpenGLDL"));
}

FE_DL_EXPORT Library* CreateLibrary(sp<Master> spMaster)
{

	Library *pLibrary = new Library();

	pLibrary->add<DrawHydra>("DrawI.DrawHydra.fe");

	return pLibrary;
}

FE_DL_EXPORT void InitializeLibrary(sp<Library> spLibrary)
{
	//* USD thread-safe call to glewInit()
	GlfGlewInit();

	//* NOTE this is not what the manifest says
	//* Once USD gets loaded, it takes priority.
	spLibrary->registry()->prioritize("DrawI.DrawHydra.fe",2);
}

}
