import sys
import re
forge = sys.modules["forge"]

import os.path

def setup(module):

	srcList = [	"DrawPlant",
				"LimberOp",
				"PlantSketch",
				"SimPlant",
				"Tree",
				"TreeOp",
				"vegetation.pmh",
				"vegetationDL" ]

	manifest = 'ext/vegetation/manifest.cc'
	with open(manifest, 'w') as outfile:
		outfile.write("")
	for src in srcList:
			if re.compile(r'(.*)Op$').match(src):
				with open(manifest, 'a') as outfile:
					outfile.write('\tspManifest->catalog<String>(\n'+
							'\t\t\t"OperatorSurfaceI.' + src + '.fe")='+
							'"fexVegetationDL";\n');

	deplibs = forge.corelibs + [
				"fexMathLib",
				"fexOperateDLLib",
				"fexSurfaceDLLib"]

	module.cppmap = {}

	if 'solve' in forge.module_list and os.path.exists('ext/solve'):
		module.cppmap['solve'] = ' -DFE_VEG_SOLVE'
	else:
		forge.color_on(0, forge.BLUE)
		sys.stdout.write(" -solve")
		forge.color_off()

	dll = module.DLL( "fexVegetationDL", srcList )

	forge.deps( ["fexVegetationDLLib"], deplibs )

	forge.tests += [
		("inspect.exe",		"fexVegetationDL",				None,		None) ]

	if 'viewer' in forge.module_list and os.path.exists('ext/viewer') and os.path.exists('ext/vegetation/test'):
		module.cppmap['solve'] = ' -DFE_VEG_VIEWER'
		module.Module( 'test' )
	else:
		forge.color_on(0, forge.BLUE)
		sys.stdout.write(" -viewer")
		forge.color_off()
