prefix = "[35mlua[0m "

-- persistant counter
if count == nil then
	count = 0
end

print("\n" .. prefix .. "FRAME " .. frame .. " COUNT " .. count)

if count == 0 then
	print (prefix .. "Import skin")
	importOp = createOperator("ImportOp")
	importOp["loadfile"] = "skin.rg"
	skin = importOp()

--	print (prefix .. "Subdivide skin")
--	subdivideOp = createOperator("SubdivideOp")
--	subdivideOp["depth"] = 1
--	subdivided = subdivideOp(skin)

	print (prefix .. "Scatter cores")
	scatterOp_cores = createOperator("ScatterOp")
	scatterOp_cores["density"] = 10
	cores = scatterOp_cores(skin)

	print (prefix .. "Scatter follicles")
	scatterOp = createOperator("ScatterOp")
	scatterOp["density"] = 900 --1700
	follicles = scatterOp(skin)

	print (prefix .. "Create curve")
	curveCreateOp = createOperator("CurveCreateOp")
	curveCreateOp["segments"] = 80
	strand = curveCreateOp()

	print (prefix .. "Copy strand")
	surfaceCopyOp= createOperator("SurfaceCopyOp")
	strands = surfaceCopyOp(strand, follicles)

	surfaceCopyOp_guides= createOperator("SurfaceCopyOp")
	guides = surfaceCopyOp_guides(strand, cores)

	print (prefix .. "Color strands")
	surfaceAttrCreateOp= createOperator("SurfaceAttrCreateOp")
	surfaceAttrCreateOp["name"] = "Cd"
	surfaceAttrCreateOp["type"] = "vector"
	surfaceAttrCreateOp["default"] = "1 0.8 0.5"
	strands = surfaceAttrCreateOp(strands)

	use_OpenCL = true

	if use_OpenCL then
		cacheOp = createOperator("CacheCLOp")
		flatnessOp = createOperator("FlatnessCLOp")
		curlOp = createOperator("CurlCLOp")
		kinkOp = createOperator("KinkCLOp")
		clumpOp = createOperator("ClumpCLOp")
		contractOp = createOperator("ContractCLOp")
	else
		-- TODO need the copy-back to CPU memory
		cacheOp = createOperator("NullOp")
		flatnessOp = createOperator("FlatnessOp")
		curlOp = createOperator("CurlOp")
		kinkOp = createOperator("KinkOp")
		clumpOp = createOperator("ClumpOp")
		contractOp = createOperator("ContractOp")
	end

--	transformOp = createOperator("TransformCLOp")
end

rotateTip = 0.8
amplitude = 0.04 -- *math.sin(0.2*count)
spin = 4
amplitudeTip = 0.2
convergenceTip = 0.9
contraction = 0.5

-- use option variables, if set
if curl_amplitude ~= nil then
	amplitude = curl_amplitude
end
if curl_spin ~= nil then
	spin = curl_spin
end

period=30

--TEMP
--count=149
if frame>0 then
	count=frame
end

-- animated ramps
step = count%(6*period)
if step<period then
	rotateTip = rotateTip *step/period
	amplitudeTip = 0
	amplitude = 0
	convergenceTip = 0
	contraction = 0
elseif step<(2*period) then
	amplitude = amplitude * (step/period-1)
	amplitudeTip = 0
	convergenceTip = 0
	contraction = 0
elseif step<(3*period) then
	amplitudeTip = amplitudeTip * (step/period-2)
	convergenceTip = 0
	contraction = 0
elseif step<(4*period) then
	convergenceTip = convergenceTip * (step/period-3)
	contraction = 0
elseif step<(5*period) then
	contraction = contraction * (step/period-4)
else
	fraction = 1-(step/period-5)
	rotateTip = rotateTip * fraction
	amplitudeTip = amplitudeTip * fraction
	amplitude = amplitude * fraction
	convergenceTip = convergenceTip * fraction
	contraction = contraction * fraction
end

print (prefix .. "Cache (clone)")
curves = cacheOp(strands)

print (prefix .. "Flatness")
flatnessOp["rotateRoot"] = rotateTip * 0.5
flatnessOp["rotateTip"] = rotateTip
flattened=flatnessOp(curves)

print (prefix .. "Curl")
curlOp["amplitude"] = amplitude
curlOp["spin"] = spin
curled=curlOp(flattened)

print (prefix .. "Kink")
kinkOp["amplitudeTip"] = amplitudeTip
kinkOp["amplitudeRandom"] = 0.05
kinkOp["frequencyRoot"] = 4.0
kinkOp["frequencyTip"] = 4.0
kinked = kinkOp(curled)

print (prefix .. "Clump")
clumpOp["convergenceTip"] = convergenceTip
clumped=clumpOp(curled,guides)

print (prefix .. "Contract")
contractOp["contraction"] = contraction
contracted=contractOp(curled)

--print (prefix .. "Transform")
--angle = 0.01*count
--transformOp["rotateX"] = Vector3( math.cos(angle), 0, -math.sin(angle) )
--transformOp["rotateZ"] = Vector3( math.sin(angle), 0, math.cos(angle) )
--spun=transformOp(curled)

output=contracted
count = count + 1

print (prefix .. "Complete")
